Subject: Doctrine semantical error

Description

| have a signal&slots implementation for failed login attempts. A repository adds a new Event model everytime this happens.

In Development context this works fine, in Production context it doesn't.

When extending the standard Flow repository, the error is:
Uncaught exception #1337934455 in line 79 of
Packages/Framework/TYPO3.Flow/Classes/TYPO3/Flow/Persistence/Repository.php: Could not add object of type
"My\App\Domain\Model\Log\Event"

When extending the doctrine repository, the following exception is thrown:
Uncaught exception in line 640 of Packages/Libraries/doctrine/annotations/lib/Doctrine/Common/Annotations/DocParser.php:
[Semantical Error] The annotation "@\TYPOS3\Flow\Annotations\Entity" in class My\App\Domain\Model\Log\Event does not
exist, or could not be auto-loaded

When debugging the exception the Flow repository throws, it eventually throws the same exception as the doctrine one.

I've tested this on both the current Git master and the beta 3 tag.

Other events that use the same code do work and my model does ofcourse have the correct annotations and use statements.

Associated revisions

Revision ec698a03 - 2013-05-28 15:38 - Rens Admiraal

[BUGFIX] Doctrine DocParser ignores Flow autoloader

The Doctrine DocParser does not utilize the autoloaders
registered into spl_autoload. This change registers

the Flow autoloader into Doctrines AnnotionRegistry so
it will be used in the lookup.

The error only occurs in Production context, but
it's hard to say how this change can be verified as
it seems to be very specific when the error occurs
and does not have to occur for all controller /
action combinations in the application.

Change-Id: 18c9e69ba77bbf112a0d1705a3458d746cccfc66d
Resolves: #48551
Releases: master, 2.0

Revision 6220799 - 2013-06-24 18:20 - Rens Admiraal

[BUGFIX] Doctrine DocParser ignores Flow autoloader

The Doctrine DocParser does not utilize the autoloaders
registered into spl_autoload. This change registers

the Flow autoloader into Doctrines AnnotionRegistry so
it will be used in the lookup.

The error only occurs in Production context, but
it's hard to say how this change can be verified as
it seems to be very specific when the error occurs
and does not have to occur for all controller /
action combinations in the application.

Change-Id: 18c9e69ba77bbf112a0d1705a3458d746cccfc66d

Resolves: #48551
Releases: master, 2.0

History

#1 - 2013-05-26 18:30 - Sebastian Kurfuerst

FYI: this bug seems to be also in http://forum.typo3.org/index.php/t/196946/

#2 - 2013-05-26 18:59 - Rens Admiraal
- Category changed from Annotations to Core
- PHP Version deleted (5.4)

I've had a similar issue in a project and did some debugging. Turned out that | could make a new instance of the class right after

initializeClassLoader() in the Flow bootstrap. Doctrine DocParser fails in loading the class though, and it seems like Doctrine in some way does not use
the classloader from Flow. Needs some more investigation.

| removed the PHP version as | know of people having this issue on 5.3 too, target version is ok as this could even be a blocker for the release.

As a DIRTY workaround you can temporary do an include of the classes in your own Package.php or if you've a customized index.php already you can
do it there. Keep in mind to remove those includes when the bug is fixed and only use it to keep your project running for now! It's a dirty fix, but better
then running in development context ;-)

#3 - 2013-05-26 19:33 - Dennis de Jong

Same issue here as Rens Admiraal, thanks for the (DIRTY!) workaround tip, that seems to work :)
#4 - 2013-05-28 15:39 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/21132

#5 - 2013-06-24 18:22 - Gerrit Code Review

Patch set 1 for branch 2.0 has been pushed to the review server.
It is available at https://review.typo3.org/21644

#6 - 2013-06-25 00:35 - Rens Admiraal
- Status changed from Under Review to Resolved

- % Done changed from 0 to 100

Applied in changeset commit:6e22079902e0b2c7d0683242b463ce9982d2e473.
